#ifndef _STDAFX_H
#define _STDAFX_H

#include <stdio.h>
#include <assert.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>

#define BSWAP32(x) ((((x) >> 24) & 0xFF) | (((x) >> 8) & 0xFF00) | (((x) << 8) & 0xFF0000) | (((x) << 24) & 0xFF000000))
#define BSWAP16(x) ((x) >> 8 | (x) << 8)


#define WITH_SDL
#define WITH_ZLIB
#define OTTD_ALIGNMENT

// by default we use [] var arrays
#define VARARRAY_SIZE

#define GCC_PACK
#define NO_DEBUG_MESSAGES
#define strdup _strdup
#define assert_compile(x)
#define NOT_REACHED() 

// Stuff for MSVC
#if defined(_MSC_VER)
#define FORCEINLINE __forceinline
#define inline _inline
//#	define CDECL _cdecl
int CDECL snprintf(char *str, size_t size, const char *format, ...);
int CDECL vsnprintf(char *str, size_t size, const char *format, va_list ap);
#endif
 #define TTD_LITTLE_ENDIAN

#define PATHSEP "\\"

typedef unsigned char byte;
typedef unsigned char uint8;
typedef unsigned short uint16;
typedef unsigned int uint32;

#ifndef CDECL
#define	CDECL
#endif
#ifdef __WINS__
#define NORETURN __declspec(noreturn)
#define INLINE _inline 
#else
#define NORETURN
#endif

// This is already defined in unix
	typedef unsigned int uint;

typedef signed char int8;
typedef signed short int16;
typedef signed int int32;
#ifndef __cplusplus
typedef unsigned char bool;
#endif
typedef signed __int64 int64;
typedef unsigned __int64 uint64;

// Setup alignment and conversion macros
#if defined(TTD_BIG_ENDIAN)
  static inline uint32 TO_LE32(uint32 x) { return BSWAP32(x); }
  static inline uint16 TO_LE16(uint16 x) { return BSWAP16(x); }
  static inline uint32 FROM_LE32(uint32 x) { return BSWAP32(x); }
  static inline uint16 FROM_LE16(uint16 x) { return BSWAP16(x); }
# define TO_BE32(x)   (x)
# define TO_BE16(x)   (x)
# define FROM_BE32(x) (x)
# define FROM_BE16(x) (x)
# define TO_LE32X(x)  BSWAP32(x)
# define TO_BE32X(x)  (x)
#else
  static inline uint32 TO_BE32(uint32 x) { return BSWAP32(x); }
  static inline uint16 TO_BE16(uint16 x) { return BSWAP16(x); }
  static inline uint32 FROM_BE32(uint32 x) { return BSWAP32(x); }
  static inline uint16 FROM_BE16(uint16 x) { return BSWAP16(x); }
# define TO_LE32(x)   (x)
# define TO_LE16(x)   (x)
# define FROM_LE32(x) (x)
# define FROM_LE16(x) (x)
# define TO_LE32X(x)  (x)
# define TO_BE32X(x)  BSWAP32(x)
#endif /* TTD_BIG_ENDIAN */

#if !defined(GAME_DATA_DIR)
# define GAME_DATA_DIR ""
#endif

#if !defined(PERSONAL_DIR)
# define PERSONAL_DIR ""
#endif

#ifndef __cplusplus
# ifndef __BEOS__
   enum {
    false = 0,
    true = 1,
   };
# endif
#endif

assert_compile(sizeof(uint32) == 4);
assert_compile(sizeof(uint16) == 2);
assert_compile(sizeof(uint8)  == 1);

#define lengthof(x) (sizeof(x)/sizeof(x[0]))
#define endof(x) (&x[lengthof(x)])
#define lastof(x) (&x[lengthof(x) - 1])
#ifndef offsetof
# define offsetof(s,m)   (size_t)&(((s *)0)->m)
#endif


#endif // !defined(_STDAFX_H)
