#include <e32base.h>
#include <bautils.h>
#include <eikenv.h>
#include <string.h>
#include <f32file.h>
extern "C"
{
#include "stdafx.h"
#include "openttd.h"
#include "window.h"
#include "hal.h"
#include "thread.h"
#include "strings.h"
#include "variables.h"
#include "functions.h"
#include <dirent.h>
#include <sys\unistd.h>
#include <stdarg.h>

#include "ttdstring.h"
#include <sdl.h>
char *strdup(const char *s) {
	char *str;
	str=(char *)malloc(strlen(s)+1);
	strcpy(str,s);
	return str;
}
	void Sleep(TUint milliSecs)
	{
		User::After(milliSecs*1000);
	}
		
int g_HIDPI_Width = 320;
int g_HIDPI_Height = 240;
bool hires = false;

struct Thread {
	TInt thread;
	ThreadFunc func;
	void* arg;
	void* ret;
};
	Thread* OTTDCreateThread(ThreadFunc function, void* arg)
	{
		Thread* t = (Thread*)malloc(sizeof(*t));
	/*	DWORD dwThreadId;
		
		if (t == NULL) return NULL;
		
		t->func = function;
		t->arg  = arg;
		t->thread = CreateThread(NULL, 0, Proxy, t, 0, &dwThreadId);
		
		if (t->thread != NULL) {
			return t;
		} else {
			free(t);
			return NULL;
		}*/
		return NULL;
	}
	
	void* OTTDJoinThread(Thread* t)
	{
		void* ret;
		
		if (t == NULL) return NULL;
		
	/*	WaitForSingleObject(t->thread, INFINITE);
		CloseHandle(t->thread);
		ret = t->ret;
		free(t);*/
		return ret;
	}

static char *_fios_path;
static char *_fios_save_path;
static char *_fios_scn_path;
static FiosItem *_fios_items;
static int _fios_count, _fios_alloc;

static FiosItem *FiosAlloc(void)
{
	if (_fios_count == _fios_alloc) {
		_fios_alloc += 256;
		_fios_items = (FiosItem*) realloc(_fios_items, _fios_alloc * sizeof(FiosItem));
	}
	return &_fios_items[_fios_count++];
}

int compare_FiosItems(const void *a, const void *b)
{
	const FiosItem *da = (const FiosItem *)a;
	const FiosItem *db = (const FiosItem *)b;
	int r;

	if (_savegame_sort_order & SORT_BY_NAME) {
		r = strcasecmp(da->title, db->title);
	} else {
		r = da->mtime < db->mtime ? -1 : 1;
	}

	if (_savegame_sort_order & SORT_DESCENDING) r = -r;
	return r;
}


// Get a list of savegames
FiosItem *FiosGetSavegameList(int *num, int mode)
{
	FiosItem *fios;
	//DIR *dir;
	//struct dirent *dirent;

	int sort_start;
	char filename[MAX_PATH];

	if (_fios_save_path == NULL) {
		_fios_save_path = (char*) malloc(MAX_PATH);
		strcpy((char*) _fios_save_path, (const char*) _path.save_dir);
	}

	_fios_path = _fios_save_path;



	// Parent directory, only if not in root already.
	if (_fios_path[3] != '\0') {
		fios = FiosAlloc();
		fios->type = FIOS_TYPE_PARENT;
		fios->mtime = 0;
		strcpy(fios->name, "..");
		strcpy(fios->title, ".. (Parent directory)");
	}

	// Show subdirectories first
	//dir = opendir(_fios_path);

	TFileName path;
	TBuf8<256>fname;
	TPtrC8 ptr((unsigned char*)_fios_path, strlen(_fios_path));
	path.Copy(ptr);
	if(path.Length()>0 && path[path.Length()-1] != '\\')
		path.Append('\\');
	RFs& fs = CEikonEnv::Static()->FsSession();
	CDir * dirList = NULL;
	if(fs.GetDir(path,KEntryAttMaskSupported ,ESortByName, dirList) == KErrNone)
	{
	  if(dirList != NULL)
	  {
	//if (dir != NULL) {
		TInt pos = 0;
		TInt cnt = dirList->Count();
		while (/*(dirent = readdir(dir)) != NULL*/pos<cnt) {	
			fname.Copy((*dirList)[pos].iName);	
		
			sprintf(filename, "%s\\%s",
				_fios_path,(char*) fname.PtrZ());
			if ((*dirList)[pos].IsDir() &&
					filename[0] != '.') {
				fios = FiosAlloc();
				fios->type = FIOS_TYPE_DIR;
				fios->mtime = 0;
				ttd_strlcpy(fios->name, (char*)fname.PtrZ(), lengthof(fios->name));
				sprintf(fios->title, "%s\\ (Directory)", FS2OTTD((char*)fname.PtrZ()));
				str_validate(fios->title);
			}
			pos++;
		}
		delete dirList;
		dirList = NULL;
	  }
	}

	{
		/* XXX ugly global variables ... */
		byte order = _savegame_sort_order;
		_savegame_sort_order = SORT_BY_NAME | SORT_ASCENDING;
		//qsort(_fios_items, _fios_count, sizeof(FiosItem), compare_FiosItems);
		_savegame_sort_order = order;
	}

	// this is where to start sorting
	sort_start = _fios_count;

	/* Show savegame files
	 * .SAV OpenTTD saved game
	 * .SS1 Transport Tycoon Deluxe preset game
	 * .SV1 Transport Tycoon Deluxe (Patch) saved game
	 * .SV2 Transport Tycoon Deluxe (Patch) saved 2-player game
	 */
	//dir = opendir(_fios_path);
	//if (dir != NULL) {
	if(fs.GetDir(path,KEntryAttMaskSupported ,ESortByName, dirList) == KErrNone)
	{
	  if(dirList != NULL)
	  {
	//if (dir != NULL) {
		TInt pos = 0;
		TInt cnt = dirList->Count();
		while (/*(dirent = readdir(dir)) != NULL*/pos<cnt) {
			char *t;
		
			fname.Copy((*dirList)[pos].iName);		
		
			sprintf(filename, "%s\\%s",
				_fios_path, (char*)fname.PtrZ());
			if ((*dirList)[pos].IsDir()) {pos++;continue;}

			t = strrchr((char*)fname.PtrZ(), '.');
			if (t == NULL) {pos++;continue;}

			if (strcasecmp(t, ".sav") == 0) { // OpenTTD
				fios = FiosAlloc();
				fios->type = FIOS_TYPE_FILE;
				fios->mtime =(*dirList)[pos].iModified.Int64();
				ttd_strlcpy(fios->name, (char*)fname.PtrZ(), lengthof(fios->name));

				*t = '\0'; // strip extension
				ttd_strlcpy(fios->title, FS2OTTD((char*)fname.PtrZ()), lengthof(fios->title));
				str_validate(fios->title);
			} else if (mode == SLD_LOAD_GAME || mode == SLD_LOAD_SCENARIO) {
				if (strcasecmp(t, ".ss1") == 0 ||
						strcasecmp(t, ".sv1") == 0 ||
						strcasecmp(t, ".sv2") == 0) { // TTDLX(Patch)
					fios = FiosAlloc();
					fios->type = FIOS_TYPE_OLDFILE;
					fios->mtime = (*dirList)[pos].iModified.Int64();
					ttd_strlcpy(fios->name, (char*)fname.PtrZ(), lengthof(fios->name));
					GetOldSaveGameName(fios->title, filename);
				}
			}
			pos++;
		}
		//closedir(dir);
		delete dirList;
		dirList = NULL;
	  }
	}

	//qsort(_fios_items + sort_start, _fios_count - sort_start, sizeof(FiosItem), compare_FiosItems);
	/* get available drive letters */
	TVolumeInfo volumeInfo;
	for (TInt disk = 0; disk < KMaxDrives; ++disk) {
		if(fs.Volume(volumeInfo, disk) == KErrNone){		
				fios = FiosAlloc();
				fios->type = FIOS_TYPE_DRIVE;
				sprintf(fios->name, "%c:", 'A' + disk);
				sprintf(fios->title, "%c:", 'A' + disk);
			}
		}

	*num = _fios_count;
	return _fios_items;
}

// Get a list of scenarios
// FIXME: Gross code duplication with FiosGetSavegameList()
FiosItem *FiosGetScenarioList(int *num, int mode)
{
	FiosItem *fios;
//	DIR *dir;
//	struct dirent *dirent;
	int sort_start;
	char filename[MAX_PATH];

	if (_fios_scn_path == NULL) {
		_fios_scn_path = (char*) malloc(MAX_PATH);
		strcpy(_fios_scn_path, _path.scenario_dir);
	}

	_fios_path = _fios_scn_path;

	// Parent directory, only if not of the type C:\.
	if (_fios_path[3] != '\0' && mode != SLD_NEW_GAME) {
		fios = FiosAlloc();
		fios->type = FIOS_TYPE_PARENT;
		fios->mtime = 0;
		strcpy(fios->title, ".. (Parent directory)");
	}
	TFileName path;

	TBuf8<256>fname;
	TPtrC8 ptr((unsigned char*)_fios_path, strlen(_fios_path));
	path.Copy(ptr);
	if(path.Length()>0 && path[path.Length()-1] != '\\')
		path.Append('\\');
	RFs& fs = CEikonEnv::Static()->FsSession();
	CDir * dirList = NULL;

	// Show subdirectories first
	//dir = opendir(_fios_path);
	if (/*dir != NULL*/ fs.GetDir(path,KEntryAttMaskSupported ,ESortByName,dirList) == KErrNone) {
		if(dirList != NULL)
		{
		TInt pos = 0;
		TInt cnt = dirList->Count();
		while (/*(dirent = readdir(dir)) != NULL*/pos<cnt) {			
			fname.Copy((*dirList)[pos].iName);
		
			sprintf(filename, "%s%s",
				_fios_path, (char*) fname.PtrZ());
			if ((*dirList)[pos].IsDir() &&
					fname[0] != '.') {
				fios = FiosAlloc();
				fios->type = FIOS_TYPE_DIR;
				fios->mtime = 0;
				ttd_strlcpy(fios->name, (char*) fname.PtrZ(), lengthof(fios->name));
				sprintf(fios->title, "%s\\ (Directory)", FS2OTTD((char*) fname.PtrZ()));
				str_validate(fios->title);
			}
			pos++;
		}
		//closedir(dir);
		delete dirList;
		dirList = NULL;
		}
	}

	{
		/* XXX ugly global variables ... */
		byte order = _savegame_sort_order;
		_savegame_sort_order = SORT_BY_NAME | SORT_ASCENDING;
		//qsort(_fios_items, _fios_count, sizeof(FiosItem), compare_FiosItems);
		_savegame_sort_order = order;
	}

	// this is where to start sorting
	sort_start = _fios_count;

	/* Show scenario files
	 * .SCN OpenTTD style scenario file
	 * .SV0 Transport Tycoon Deluxe (Patch) scenario
	 * .SS0 Transport Tycoon Deluxe preset scenario
	 */
//	dir = opendir(_fios_path);
	if (/*dir != NULL*/ fs.GetDir(path, KEntryAttMaskSupported ,ESortByName, dirList) == KErrNone) {

		if(dirList != NULL)
		{
		TInt pos = 0;
		TInt cnt = dirList->Count();
		while (/*(dirent = readdir(dir)) != NULL*/pos<cnt) {
			char *t;		
			fname.Copy((*dirList)[pos].iName);
		
			sprintf(filename, "%s%s", _fios_path, (char*) fname.PtrZ());
			if ((*dirList)[pos].IsDir()) {pos++;continue;}

			t = strrchr((char*) fname.PtrZ(), '.');
			if (t == NULL) {pos++;continue;}

			if (strcasecmp(t, ".scn") == 0) { // OpenTTD
				fios = FiosAlloc();
				fios->type = FIOS_TYPE_SCENARIO;
				fios->mtime = (*dirList)[pos].iModified.Int64();
				ttd_strlcpy(fios->name, (char*) fname.PtrZ(), lengthof(fios->name));

				*t = '\0'; // strip extension
				ttd_strlcpy(fios->title, FS2OTTD((char*) fname.PtrZ()), lengthof(fios->title));
				str_validate(fios->title);
			} else if (mode == SLD_LOAD_GAME || mode == SLD_LOAD_SCENARIO ||
					mode == SLD_NEW_GAME) {
				if (strcasecmp(t, ".sv0") == 0 ||
						strcasecmp(t, ".ss0") == 0) { // TTDLX(Patch)
					fios = FiosAlloc();
					fios->type = FIOS_TYPE_OLD_SCENARIO;
					fios->mtime = (*dirList)[pos].iModified.Int64();
					GetOldScenarioGameName(fios->title, filename);
					ttd_strlcpy(fios->name, (char*) fname.PtrZ(), lengthof(fios->name));
				}
			}
			pos++;
		}
		delete dirList;
		dirList = NULL;
	//	closedir(dir);
		}
	}

	//qsort(_fios_items + sort_start, _fios_count - sort_start, sizeof(FiosItem), compare_FiosItems);
		// Drives
	TVolumeInfo volumeInfo;
	if (mode != SLD_NEW_GAME) {

		/* get available drive letters */

		for (TInt disk = 0; disk < KMaxDrives; ++disk) {
			if(fs.Volume(volumeInfo, disk) == KErrNone) {
				fios = FiosAlloc();
				fios->type = FIOS_TYPE_DRIVE;
				sprintf(fios->name, "%c:", 'A' + disk);
				sprintf(fios->title, "%c:", 'A' + disk);
			}
		}

	}

	*num = _fios_count;
	return _fios_items;
}


// Free the list of savegames
void FiosFreeSavegameList(void)
{
	free(_fios_items);
	_fios_items = NULL;
	_fios_alloc = _fios_count = 0;
}

// Browse to
char *FiosBrowseTo(const FiosItem *item)
{
	char *path = _fios_path;
	char *s;

	switch (item->type) {
		case FIOS_TYPE_DRIVE:
			sprintf(path, "%c:\\", item->title[0]);
		break;
		case FIOS_TYPE_PARENT:
			s = strrchr(path, '\\');
			if (s != path + 2)
				s[0] = '\0';
			else
				s[1] = '\0';
			break;

		case FIOS_TYPE_DIR:
			if (path[3] != '\0') strcat(path, "\\");
			strcat(path, item->name);
			break;

		case FIOS_TYPE_DIRECT:
			sprintf(path, "%s\\", item->name);
			s = strrchr(path, '\\');
			if (s[1] == '\0') s[0] = '\0'; // strip trailing slash
			break;

		case FIOS_TYPE_FILE:
		case FIOS_TYPE_OLDFILE:
		case FIOS_TYPE_SCENARIO:
		case FIOS_TYPE_OLD_SCENARIO: {
			static char str_buffr[512];

			sprintf(str_buffr, "%s\\%s", path, item->name);
			return str_buffr;
		}
	}

	return NULL;
}

/**
 * Get descriptive texts. Returns the path and free space
 * left on the device
 * @param path string describing the path
 * @param tfs total free space in megabytes, optional (can be NULL)
 * @return StringID describing the path (free space or failure)
 */
StringID FiosGetDescText(const char **path, uint32 *tot)
{
	uint32 free = 0;
	*path = _fios_path;

#ifdef HAS_STATVFS
	{
		struct statvfs s;

		if (statvfs(*path, &s) == 0) {
			free = (uint64)s.f_frsize * s.f_bavail >> 20;
		} else
			return STR_4006_UNABLE_TO_READ_DRIVE;
	}
#endif
	if (tot != NULL) *tot = free;
	return STR_4005_BYTES_FREE;
}

void FiosMakeSavegameName(char *buf, const char *name, size_t size)
{
	const char* extension;
	const char* period;

	if (_game_mode == GM_EDITOR)
		extension = ".scn";
	else
		extension = ".sav";

	// Don't append the extension, if it is already there
	period = strrchr(name, '.');
	if (period != NULL && strcasecmp(period, extension) == 0) extension = "";

	sprintf(buf, /*size,*/ "%s\\%s%s", _fios_path, name, extension);
}

bool FiosDelete(const char *name)
{
	char path[512];

	FiosMakeSavegameName(path, name, sizeof(path));
	return unlink(path) == 0;
}

bool FileExists(const char *filename)
{
	return access(filename, 0) == 0;
}

static int LanguageCompareFunc(const void *a, const void *b)
{
	return strcmp(*(const char* const *)a, *(const char* const *)b);
}

int GetLanguageList(char **languages, int max)
{
	int num = 0;
	TFileName path;
	TBuf8<256>filename;
	TPtrC8 ptr((unsigned char*)_path.lang_dir, strlen(_path.lang_dir));
	path.Copy(ptr);
	path.Append(_L("*.lng"));
	RFs& fs = CEikonEnv::Static()->FsSession();
	CDir * dirList = NULL;
	if(fs.GetDir(path,KEntryAttMaskSupported ,ESortByName, dirList) == KErrNone)
	{
		if(dirList != NULL)
		{
			TInt cnt = dirList->Count();
			
			for(TInt loop = 0;loop<cnt;loop++) 
			{
				if(!(*dirList)[loop].IsDir())
				{
				filename.Copy((*dirList)[loop].iName);			
				languages[num++] = (char*)strdup((char*)filename.PtrZ());
				if (num == max) break;			
				}
			}
			delete dirList;
		}
		
	}
	//qsort(languages, num, sizeof(char*), LanguageCompareFunc);
	return num;
}

#if defined(__BEOS__) || defined(__linux__)
static void ChangeWorkingDirectory(char *exe)
{
	char *s = strrchr(exe, '\\');
	if (s != NULL) {
		*s = '\0';
		chdir(exe);
		*s = '\\';
	}
}
#endif

void ShowInfo(const char *str)
{
	TPtrC8 ptr((unsigned char*) str, strlen(str));
	HBufC* buf = HBufC::NewLC(ptr.Length());
	buf->Des().Copy(ptr);
	CEikonEnv::Static()->InfoWinL(_L("OTTD Info"), *buf);
	CleanupStack::PopAndDestroy(buf);
}

void ShowOSErrorBox(const char *str)
{
/*#if defined(__APPLE__)
	// this creates an NSAlertPanel with the contents of 'buf'
	// this is the native and nicest way to do this on OSX
	ShowMacDialog( buf, "See readme for more info\nMost likely you are missing files from the original TTD", "Quit" );
#else
	// all systems, but OSX
	fprintf(stderr, "\033[1;31mError: %s\033[0;39m\n", buf);
#endif*/
	TPtrC8 ptr((unsigned char*) str, strlen(str));
	HBufC* buf = HBufC::NewLC(ptr.Length());
	buf->Des().Copy(ptr);
	CEikonEnv::Static()->InfoWinL(_L("OTTD Error"), *buf);
	CleanupStack::PopAndDestroy(buf);
}


int main(int argc, char* argv[])
{
	int ret;


	// change the working directory to enable doubleclicking in UIs
//	ChangeWorkingDirectory(argv[0]);

	_random_seeds[0][1] = _random_seeds[0][0] = time(NULL);
//	SeedMT(_random_seeds[0][1]);


	ret = ttd_main(/*argc, argv*/);

	return ret;
}

#ifdef __WINS__
const char KDatatPath[16] = "C:\\shared\\TTD\\";
#else
const char KDatatPath[16] = "D:\\TTD\\";
#endif
void DeterminePaths(void)
{
	char *cfg = (char*) &KDatatPath[0];
	_path.personal_dir = _path.game_data_dir = cfg;
	// MYCODE EDIT
	_path.personal_dir = cfg;
	_path.game_data_dir = cfg;

	_path.save_dir = str_fmt("%ssave", cfg);
	_path.autosave_dir = str_fmt("%s\\autosave", _path.save_dir);
	_path.scenario_dir = str_fmt("%sscenario", cfg);
	_path.gm_dir = str_fmt("%sgm\\", cfg);
	_path.data_dir = str_fmt("%sdata\\", cfg);
	_path.lang_dir = str_fmt("%slang\\", cfg);

	if (_config_file == NULL)
		_config_file = str_fmt("%sopenttd.cfg", _path.personal_dir);

	_highscore_file = str_fmt("%shs.dat", _path.personal_dir);
	_log_file = str_fmt("%sopenttd.log", _path.personal_dir);

	// make (auto)save and scenario folder
	TFileName filename;
	TPtrC8 ptr((unsigned char*) _path.save_dir, strlen(_path.save_dir));
	filename.Copy(ptr);
	BaflUtils::EnsurePathExistsL(CEikonEnv::Static()->FsSession(),filename);

	ptr.Set((unsigned char*)_path.autosave_dir, strlen(_path.autosave_dir));
	filename.Copy(ptr);
	BaflUtils::EnsurePathExistsL(CEikonEnv::Static()->FsSession(),filename);

	ptr.Set((unsigned char*)_path.scenario_dir, strlen(_path.scenario_dir));
	filename.Copy(ptr);
	BaflUtils::EnsurePathExistsL(CEikonEnv::Static()->FsSession(),filename);
//	MULTI_TO_WIDE( _path.save_dir, strWide, sizeof(strWide) );
//	CreateDirectory(strWide, NULL);
//	MULTI_TO_WIDE( _path.autosave_dir, strWide, sizeof(strWide) );
//	CreateDirectory(strWide, NULL);
//	MULTI_TO_WIDE( _path.scenario_dir, strWide, sizeof(strWide) );
//	CreateDirectory(strWide, NULL);

}

bool InsertTextBufferClipboard(Textbuf *tb)
{
	return false;
}

int  GetTickCount()
{
	return User::TickCount()/1000;
}

int snprintf(char *str, size_t size, const char *format, ...)
{
	va_list ap;
	int ret;

	va_start(ap, format);
	ret = vsprintf(str, format, ap);
	va_end(ap);
	return ret;
}
}


#include <eikapp.h>
#include <e32base.h>
#define UIQ3
#include <sdlapp.h>
#include <eikstart.h>

class COTDDApp : public CSDLApp {
public:
	COTDDApp();
	~COTDDApp();

	TUid AppDllUid() const;

	/**
	 * Returns the resource id to be used to declare the views supported by this UIQ3 app
	 * @return TInt, resource id
	 */
	TInt ViewResourceId();
};


CApaApplication* NewApplication() {
	// Return pointer to newly created CQMApp
	return new COTDDApp;
}

// E32Main() contains the program's start up code, the entry point for an EXE.
GLDEF_C TInt E32Main() {
 	return EikStart::RunApplication(NewApplication);
}

#include <OTTD.rsg>

COTDDApp::COTDDApp() {
}
/**
 * Returns the resource id to be used to declare the views supported by this UIQ3 app
 * @return TInt, resource id
 */
TInt COTDDApp::ViewResourceId() {
	return R_SDL_VIEW_UI_CONFIGURATIONS;
}

COTDDApp::~COTDDApp() {
	CloseSTDLIB();
}

/**
 *   Responsible for returning the unique UID of this application
 * @return unique UID for this application in a TUid
 **/
TUid COTDDApp::AppDllUid() const {
	return TUid::Uid(0xA00007B2);
}

